SystemOrganization addCategory: #ComposableLayouts!

ROAbstractGraphLayout subclass: #ROCircleTreeGridLayout
	instanceVariableNames: 'factor center circleT gridT'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ComposableLayouts'!

!ROCircleTreeGridLayout methodsFor: 'as yet unclassified' stamp: 'MarcelaRomero 11/6/2012 12:36'!
centeredOn: point
	circleT centeredOn: point.
	

! !

!ROCircleTreeGridLayout methodsFor: 'hook' stamp: 'MarcelaRomero 11/6/2012 12:34'!
doExecute: elements
	|  rootNodes numElements |
	
	numElements := elements size.
	
	gridT
		gapSize: factor;
		applyOn: (elements copyFrom: 1 to:  numElements/2).
	circleT
		centeredOn: elements first position;
		applyOn: (elements copyFrom: numElements/2+1 to: numElements).
	
	 
	
		
		

 ! !

!ROCircleTreeGridLayout methodsFor: 'initialize-release' stamp: 'MarcelaRomero 11/6/2012 12:33'!
initialize
	super initialize.
	circleT := ROCircleLayout new.
	gridT := ROGridLayout new.
	factor := 50.
	! !

!ROCircleTreeGridLayout methodsFor: 'accessing' stamp: 'MarcelaRomero 10/16/2012 10:24'!
scaleBy: aNumber
	"comment stating purpose of message"
	factor := aNumber.
	! !

!ROCircleTreeGridLayout methodsFor: 'accessing' stamp: 'MarcelaRomero 10/16/2012 10:26'!
scaleFactor
	"comment stating purpose of message"
	^factor
	! !

Object subclass: #NestableCircle
	instanceVariableNames: 'interaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ComposableLayouts'!

!NestableCircle methodsFor: 'as yet unclassified' stamp: 'MarcelaRomero 11/22/2012 13:30'!
mouseDraggingEvent: view

	view interaction 
	on: ROMouseDragging do: [ :event |
		(event element attributes includesKey: #childElement) ifTrue: [
			(event element attributes at: #childElement) do: [ :e | e announce: event ]
			]
		]
	
 ! !

!NestableCircle methodsFor: 'as yet unclassified' stamp: 'MarcelaRomero 12/6/2012 12:45'!
mouserClickEvent: view	
	| newElements set |
	

	view interaction 
	on: ROMouseLeftClick do: [ :event | 		
		(event element attributes includesKey: #childElement) 
		ifTrue: [			
			(event element attributes at: #childElement) do: #remove.
			event element attributes removeKey: #childElement.
			event element signalUpdate. 
			 ]	
		ifFalse: [
			view shape rectangle fillColor: Color blue.					
			newElements := view nodes: (1 to: 5).
			
			"set := Set new.
			set add: event element.
			set addAll: newElements.			
			view edges: {1->2. 1->3. 1->4. 1->5. 1->6} from: #key to: #value."
			
			ROUserCenteredLayout new
				translator: (ROSmoothLayoutTranslator new);
				centeredOn: event element position;
				applyOn: newElements.				
			
			event element signalUpdate.			
			event element attributes at: #childElement put: newElements.		
					
			
			
		]].

	"view on: ROMouseRightClick do: [ :event |
		| children |
		
		children := view nodes: (1 to: 3).
		ROUserCenteredLayout new
			translator: (ROSmoothLayoutTranslator new);
			centeredOn: (event element attributes at: #childElement) position;
			applyOn: children.
		event element attributes at: #childElement attributes at: #childrenChildren put: children.
		
		(event newElement attributes includesKey: #childElement)
		ifFalse: [
			view shape rectangle fillColor: Color red.
			children := view nodes: (1 to: 3).
			ROUserCenteredLayout new
				translator: (ROSmoothLayoutTranslator new);
				centeredOn: children;
				applyOn: children.
			event element signalUpdate.
			event element attributes at: #childElement put: children.
		]]."! !

!NestableCircle methodsFor: 'as yet unclassified' stamp: 'MarcelaRomero 12/5/2012 23:06'!
openOn: objects

"Source code: ROMondrianExample>>chooseLayoutOn:"
"Preambule. It includes the initialization. "
| view rawView |
rawView := ROView new.
view := ROMondrianViewBuilder view: rawView.
"-------------"
"-------------"


self mouserClickEvent: view.
self mouseDraggingEvent: view.

view shape rectangle size: 15.
view nodes: objects.
view circleLayout.

"-------------"
"-------------"
"Below is the initiation of the menu and opening the visualization"
ROEaselMorphic new populateMenuOn: view.
view open! !

ROTest subclass: #ROCenteredCircleLayoutTest
	instanceVariableNames: 'view elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ComposableLayouts'!

!ROCenteredCircleLayoutTest methodsFor: 'running' stamp: 'MarcelaRomero 11/6/2012 12:42'!
setUp

	elements := OrderedCollection new.
	5 timesRepeat: [ elements add: ROElement sprite ]! !

!ROCenteredCircleLayoutTest methodsFor: 'test layout' stamp: 'MarcelaRomero 10/25/2012 12:58'!
testDefaultCenter

	self assert: (ROCircleLayout new center = (0 @0))! !

!ROCenteredCircleLayoutTest methodsFor: 'test layout' stamp: 'MarcelaRomero 11/15/2012 17:27'!
testLayout

	| result positionsBeforeCenteredLayout positionsAfterCenteredLayout circ1 circ2 |
	
	circ1 := ROCircleLayout new
		applyOn: elements.
	positionsBeforeCenteredLayout := elements collect: #position.
	  
	circ2 := ROCircleLayout new
		centeredOn: 100 @ 80;
		applyOn: elements.
	positionsAfterCenteredLayout := elements collect: #position.
	

	
	self assert: (positionsBeforeCenteredLayout collect: [ :p | p + (100 @ 80) ]) = positionsAfterCenteredLayout.
	
	
	
	

		
		
	! !

!ROCenteredCircleLayoutTest methodsFor: 'test layout' stamp: 'MarcelaRomero 11/6/2012 13:26'!
testNoNegativePosition
	
	ROCircleLayout new
		applyOn: elements.
		
	self assert: (elements noneSatisfy: [ :element | element position < (0 @ 0) ])! !

!ROCenteredCircleLayoutTest methodsFor: 'test basic' stamp: 'MarcelaRomero 11/6/2012 12:43'!
testSetUp

	self assert: elements size = 5! !

!ROCenteredCircleLayoutTest methodsFor: 'test layout' stamp: 'MarcelaRomero 10/25/2012 12:59'!
testSettingACenter
	| aLayout |
	aLayout := ROCircleLayout new.
	aLayout centeredOn: 20 @ 30.
	self assert: aLayout center = (20 @ 30)! !
